"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.storiesOf = exports.setAddon = exports.raw = exports.getStorybook = exports.forceReRender = exports.configure = exports.clientApi = exports.clearDecorators = exports.channel = exports.addParameters = exports.addDecorator = void 0;

var _addons = require("@storybook/addons");

var _helpers = require("./helpers");

var _api$context;

const framework = (0, _helpers.getStorybookFramework)(); // eslint-disable-next-line @typescript-eslint/no-var-requires

const core = require((0, _helpers.resolveFromStorybook)('@storybook/core')); //@ts-expect-error: 6.2 use named exports
// eslint-disable-next-line @typescript-eslint/no-unsafe-member-access


const start = (0, _helpers.isStorybookVersionLessThan)(6, 2) ? core.default.start : core.start;
const api = start(() => void 0);
const channel = (0, _helpers.isStorybookVersionLessThan)(6, 4) ? //@ts-expect-error: 6.x has { channel }, but 5.x has { context: { channel } }
// eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
api.channel ?? ((_api$context = api.context) === null || _api$context === void 0 ? void 0 : _api$context.channel) : _addons.addons.getChannel();
exports.channel = channel;
const clientApi = api.clientApi;
exports.clientApi = clientApi;
const forceReRender = api.forceReRender;
exports.forceReRender = forceReRender;

const storiesOf = (kind, m) => {
  return clientApi.storiesOf(kind, m).addParameters({
    framework
  });
};

exports.storiesOf = storiesOf;

const configure = (...args) => {
  if ((0, _helpers.isStorybookVersionLessThan)(5, 2)) {
    //NOTE: Storybook <= 5.1 pass args as is
    //@ts-expect-error: ignore it
    // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-call
    return api.configApi.configure(...args);
  }

  if ((0, _helpers.isStorybookVersionLessThan)(6)) {
    //NOTE: Storybook <= 5.3 pass `framework` as last argument
    //@ts-expect-error: ignore it
    return api.configure(...args, framework);
  } //NOTE Storybook 6.x pass `framework` as first argument
  //@ts-expect-error: ignore it


  return api.configure(framework, ...args);
};

exports.configure = configure;
const addDecorator = clientApi.addDecorator;
exports.addDecorator = addDecorator;
const addParameters = clientApi.addParameters;
exports.addParameters = addParameters;
const clearDecorators = clientApi.clearDecorators;
exports.clearDecorators = clearDecorators;
const setAddon = clientApi.setAddon;
exports.setAddon = setAddon;
const getStorybook = clientApi.getStorybook;
exports.getStorybook = getStorybook;
const raw = clientApi.raw;
exports.raw = raw;